<template>
  <div class="form" :style="customColorStyle">
    <ul>
      <li v-if="DTCred !== null && DTCred !== undefined">{{ $t('cred') }} {{ $t('for-dtc') }} : {{ DTCred }}</li>
      <li v-else><span class="text-danger">{{ $t('no-cred') }} {{ $t('for-dtc') }}</span></li>
      <div class="custom-file">
        <input @change="changeCred($event, 'datacatalog');" type="file" class="custom-file-input">
        <label class="custom-file-label">{{ $t('modify') }}</label>
      </div>
      <li class="top" v-if="sheetCred !== null  && sheetCred !== undefined">{{ $t('cred') }} {{ $t('for-sheet') }} {{ $t('and') }} {{ $t('for-drive') }} : {{ sheetCred }}</li>
      <li class="top" v-else><span class="text-danger">{{ $t('no-cred') }} {{ $t('for-sheet') }} {{ $t('and') }} {{ $t('for-drive') }}</span></li>
      <div class="custom-file">
        <input @change="changeCred($event, 'sheet')" type="file" class="custom-file-input">
        <label class="custom-file-label">{{ $t('modify') }}</label>
      </div>
    </ul>
  </div>
</template>

<script>
import custom from '@/shared/custom'
import APICred from '@/api/credentials'
import APIGcp from '@/api/gcp'
import Vue from 'vue'
export default {
  name: 'CredentialsComponent',
  data () {
    return {
      DTCred: null, // datacatalog
      sheetCred: null
    }
  },
  methods: {
    initCred () {
      APICred.getCred().then(map => {
        this.DTCred = map.datacatalog
        this.sheetCred = map.sheet
        this.$store.commit('saveLoading', false)
      })
    },
    addAllToList (list) {
      list.unshift({
        id: '*',
        libelle: this.$t('all'),
        disponible: true
      })
      return list
    },
    getAllDataset () {
      this.$store.commit('saveLoading', true)
      const datasets = []
      APIGcp.getTDatasets().then(response => {
        response.forEach(item => {
          datasets.push({
            id: item.id,
            libelle: item.libelle,
            disponible: item.disponible
          })
        })
        Vue.prototype.$datasets = this.addAllToList(datasets)
        this.optDataset = datasets.slice(1)
        this.$store.commit('saveLoading', false)
      })
    },
    getAllTagName () {
      this.$store.commit('saveLoading', true)
      const optTagModel = []
      APIGcp.getTagModelsWithoutProjectName().then(response => {
        response.forEach(item => {
          optTagModel.push({
            id: item.id,
            libelle: item.libelle,
            disponible: item.disponible
          })
        })
        Vue.prototype.$optTagModel = this.addAllToList(optTagModel)
        this.optTagModel = optTagModel.slice(1)
        this.$store.commit('saveLoading', false)
      })
    },
    changeCred (event, type) {
      this.$store.commit('saveLoading', true)
      const file = event.target.files[0]
      const fileData = new FormData()
      fileData.append('file', file)
      APICred.changeCred(type, fileData).then(response => {
        if (response) {
          // reload datasets and tag models
          this.getAllTagName()
          this.getAllDataset()
          this.$alert(this.$t('cred-change-success') + ' (' + type + ')', this.$t('success'), 'success')
        } else {
          this.$store.commit('saveLoading', false)
          let fileType = ''
          if (type === 'sheet') {
            fileType = 'p12'
          } else if (type === 'datacatalog') {
            fileType = 'json'
          }
          this.$alert(this.$t('bad-format') + ' (' + this.$t(fileType) + ' .' + this.$t('required') + ')', this.$t('error'), 'error')
        }
      }).catch(() => {
        this.$store.commit('saveLoading', false)
        this.$alert(this.$t('error-occurred'), this.$t('error'), 'error')
      })
    }
  },
  computed: {
    customColorStyle () {
      return custom.customColorStyle()
    }
  },
  mounted () {
    custom.getGoodItemAndColorIt(this.$route.path)
  },
  created () {
    this.$store.commit('saveLoading', true)
    this.initCred()
  }
}
</script>

<style scoped>
.form {
  margin: 30px 7% 0 7%;
  border-radius: 15px;
  padding: 20px;
}
ul {
  padding: 10px 10px 10px 20px;
  margin: 0%;
  border: 0;
  box-shadow: 0
}
.top {
  margin-top: 60px;
}
</style>
